#SortCheck_v1_3_0.pl
#command line:
#script.pl input.txt output.txt

use strict;
use open ':utf8';
use utf8;
use POSIX qw(ceil floor);



sub progressinfile {#______________________
	my $state = shift;
        my $max = shift;
	my $message = shift;

   my $percent = ($state/$max)*100;
   $percent = floor($percent);

   for(my $k=0;$k<$percent;$k=$k+5)
      {
		print "|";						
      }

        print "$percent% $message";
        print "\r";

	 }#______________________




my @hw = ();



   if (@ARGV == 2)
   {


   &check;
   print "\rOK                        \n";
   }
   else
      {#//////////////////////
      print "  ________________________________\n";
      print "  Invalid command line.\n";
      print "  ________________________________\n";
      }#\\\\\\\\\\\\\\\\\\\\\\



sub prepare{

my $s = shift;

$s = lc($s);

$s =~ s/â/a/g;
$s =~ s/à/a/g; 
$s =~ s/é/e/g;
$s =~ s/ê/e/g;
$s =~ s/è/e/g;
$s =~ s/ë/e/g;
$s =~ s/î/i/g;
$s =~ s/ï/i/g;
$s =~ s/ô/o/g;
$s =~ s/û/u/g;
$s =~ s/ù/u/g;
$s =~ s/ü/u/g;
$s =~ s/ÿ/y/g;
$s =~ s/ç/c/g;
$s =~ s/\-//g;

return $s;

           }


sub check {#________________________________

   open(a, "$ARGV[0]") || die "could not open file: $!";
   open(b, ">$ARGV[1]") || die "could not open file: $!";

my $count = 0;
my $filesize = -s a;


my $h1;



while (<a>) {#- - - - - - - - - - - -
s/[\x0A\x0D]//g;


$count++;
if (($count % 2) == 0)
   {
my $offset = tell(a);
   progressinfile($offset, $filesize, "");
   }


if ($_ =~ /^(\x{feff})(.*)$/)
   {
   print b "$1";
   $_ = $2;
   }


if ($_ =~ /^\#(NAME.*|INDEX_LANGUAGE.*|CONTENTS_LANGUAGE.*)$/)
   {
   print b "\#$1\n";
   }
   else
      {#___________________


  if ($_ =~ /^[^\t\x20].*$/)
     {

     if ($h1 eq '')
        {
        $h1 = $_;
        print b "$_\n";
        }
        else
           {#. . . . . . . . .

           my $h2 = $_;

           my $h1_c = prepare($h1);
           my $h2_c = prepare($h2);


          my @tmp = ($h1_c, $h2_c);

          @tmp = sort(@tmp);


          if (($tmp[0] ne $h1_c) || ($tmp[1] ne $h2_c))
              {
              print b "$h2^^^\n";  
              }
              else
                 {
                 print b "$h2\n";  
                 }

          $h1 = $h2;

          }#. . . . . . . . .


     }
     else
        {
        print b "$_\n";
        }


     }#________________

            }#- - - - - - - - - - - - 



my $offset = tell(a);
progressinfile($offset, $filesize, "");


close a;
close b;
}#________________________________





