#pile_headwords_v1_0_2.pl
#command line:
#script.pl input.txt output.txt
#input.txt - UTF-8, dictionary

use strict;
use POSIX qw(ceil floor);
use open ':utf8';

open(a, "$ARGV[0]") || die "could not open file: $!";
open(b, ">$ARGV[1]") || die "could not open file: $!";

my $count = 0;
my $filesize = -s a;


my @arr1 = ();
my $flag = 0;
my @arr2 = ();
my $lc = 0;



sub progressinfile {#______________________
	my $state = shift;
        my $max = shift;
	my $message = shift;

   my $percent = ($state/$max)*100;
   $percent = floor($percent);

   for(my $k=0;$k<$percent;$k=$k+5)
      {
		print "|";						
      }

        print "$percent% $message";
        print "\r";

	 }#______________________





sub printarray {#_______________________

	my @s = @_;
	my @hw = ();
	foreach (@s)
            {
            if ($_ =~ /^[^\t\x20].*$/)
               {
               push @hw, $_;
               }
            }


                 my $art = "";
                 foreach(@s)
                   {
                   if ($_ =~ /^[\t\x20].*$/)
                      {
                      $art .= "$_\n";
                      }
                   }


                   if (@hw > 100)
                      {
                      print "Input file does not appear to be a dictionary.\n";
                      exit;
                      }

              $lc++;
              my $allhw = join("\n", @hw);
              my @tmp = ($allhw, $art, $lc);
              push  @arr2, [@tmp];

      }#_______________________



#||||||||||||||||||||||||||||||||||
while (<a>) {#- - - - - - - - - - - -
s/[\x0A\x0D]//g;

$count++;
if (($count % 2) == 0)
   {
my $offset = tell(a);
   progressinfile($offset, $filesize, "");
   }



if ($_ =~ /^(\x{feff})(.*)$/)
   {
   print b "$1";
   $_ = $2;
   }


if ($_ =~ /^\#(NAME.*|INDEX_LANGUAGE.*|CONTENTS_LANGUAGE.*)$/)
   {
   print b "\#$1\n";
   }
elsif (($_ =~ /^$/) && (@arr1 == 0))
   {
   print b "$_\n";
   }
elsif (($_ =~ /^[\t\x20].*$/) && (@arr1 == 0))
   {
   print b "$_\n";
   }
elsif ($_ =~ /^[^\t\x20].*$/)
    {

    if (($flag == 0) || ($flag == 2))
       {
       if (@arr1 > 0)
          {
          printarray(@arr1);
          }
          @arr1 = ();
          push @arr1, $_;
       }
       else
          {
          push @arr1, $_;
          } 

    $flag = 1;
    }
    else
        {
        push @arr1, $_;
        $flag = 2;

        }

            }#- - - - - - - - - - - -


          if (@arr1 > 0)
          {
          printarray(@arr1);
          @arr1 = ();
          }

my $offset = tell(a);
progressinfile($offset, $filesize, "");


#||||||||||||||||||||||||||||||||||


&meth2;

sub meth2 {#________________________________


my @sorted = sort {$a->[1] cmp $b->[1]} @arr2;
@arr2 = ();


 while (my $element = shift(@sorted))
                 {#- - - - - - - - - - - - - -
	
                   if (@arr2 == 0)
                      {
                      push @arr2, $element;
                      }
                      else
                         {

                        if ($element->[1] eq $arr2[$#arr2][1])
                           {#||||||||||||||||

                           $arr2[$#arr2][0] .= "\n$element->[0]";

                           }#||||||||||||||||
                           else
                              {
                              push @arr2, $element;
                              }
 
                         }

	         }#- - - - - - - - - - - - - -

@sorted = ();

my @sorted = sort {$a->[2] <=> $b->[2]} @arr2;
@arr2 = ();

foreach(@sorted)
       {#|||||||||||||||||||||||||||||   

       my $row = $_;
       print b "$row->[0]\n$row->[1]";

       }#|||||||||||||||||||||||||||||


	 }#________________________________

#||||||||||||||||||||||||||||||

print "\nOK";

close a;
close b;
