#comment_list_v1_2_1.pl
#command line:
#script.pl -dsb -[A-Za-z]{1,10} input.txt output.txt
#script.pl -dab -[A-Za-z]{1,10} input.txt output.txt

#script.pl -tab -[A-Za-z]{1,10} input.txt output.txt

use strict;
use open ':utf8';
use POSIX qw(ceil floor);


my @arr1 = ();
my $flag = 0;
my %hash1 = ();
my %hash2 = ();
my @between = ();

if ((@ARGV == 4) && ($ARGV[0] =~ /^-(dsb|dab)$/) && ($ARGV[1] =~ /^-[A-Za-z]{1,10}$/))
   {
   &readarticlesindic;
   &sortandwrite;
   print "\nOK";
   }
elsif ((@ARGV == 4) && ($ARGV[0] eq '-tab') && ($ARGV[1] =~ /^-[A-Za-z]{1,10}$/))
   {
   &readtext;
   &sortandwrite;
   print "\nOK";
   }
   else
      {
      print "  ________________________________\n";
      print "  Invalid command line.\n";
      print "  ________________________________\n";
      exit;
      }


sub progressinfile {#__________________________
	my $state = shift;
        my $max = shift;
	my $message = shift;

   my $percent = ($state/$max)*100;
   $percent = floor($percent);

   for(my $k=0;$k<$percent;$k=$k+5)
      {
		print "|";						
      }

        print "$percent% $message";
        print "\r";

	 }#__________________________



sub meth1 {#__________________________
	my $s = shift;



   my @char_array = split(//, $s);
   foreach(@char_array)
          {
          $hash1{$_} = 'x';
          }


   if ($ARGV[0] eq '-dsb')
       {
       $s =~ s/\[c [a-z]+\]//g;
       $s =~ s/\[[a-z\*\!]+\]//g;
       $s =~ s/\[[\/a-z\*\!]+\]//g;
       }
       else
          {
          $s =~ s/<[^<>]*>//g;
          }

   my @word_array = split(/[ ,]/, $s);
   foreach(@word_array)
          {
          $hash2{$_} = 'x';
          }


	 }#__________________________


sub retrievecomm {#_________________________

        $ARGV[1] =~ /^-([A-Za-z]{1,10})$/;
        my $name = $1;

                 my $s = shift;

                 if ($ARGV[0] eq '-dsb')
                    {#///////////////////////// 

                 $s =~ s/,/\&\#44;/g;
                 $s =~ s/\[$name\]/,\[$name\]/gi;
                 $s =~ s/\[\/$name\]/\[\/$name\],/gi;
                 my @arrloc = split(/,/, $s);
                       foreach (@arrloc)
                               {
                                 if ($_ =~ /^\[$name\](.+)\[\/$name\]$/is)
                                    {
                                    my $p = $1;
                                    $p =~ s/\&\#44;/,/g;
                                    if ($p ne "")
                                       {
                                       $p =~ s/\n[\t\x20]+/\x20/g;
                                       push @between, $p;
                                       meth1($p);
                                       }
                                    }
               	                }

               	    }#/////////////////////////
               	    else
                       {#\\\\\\\\\\\\\\\\\\\\\\\\

                        $s =~ s/,/\&\#44;/g;
                        $s =~ s/(<$name>)/,$1/gi;
                        $s =~ s/(<\/$name>)/$1,/gi;
                        my @arrloc = split(/,/, $s);
                              foreach (@arrloc)
                                      {
                                        if ($_ =~ /^<$name>(.+)<\/$name>$/is)
                                           {
                                           my $p = $1;
                                           $p =~ s/\&\#44;/,/g;
                                           if ($p ne "")
                                              {
                                              $p =~ s/\n[\t\x20]+/\x20/g;
                                              push @between, $p;
                                              meth1($p);
                                              }
                                           }
                    	                }

                       }#\\\\\\\\\\\\\\\\\\\\\\\\
                }#_________________________



sub printarray {#___________________
	my @s = @_;
      	my @hw = ();
        my $art = "";

            	foreach (@s)
                        {
                        if ($_ =~ /^[^\t\x20].*$/)
                           {
                           push @hw, $_;
                           }
                        }


                 foreach(@s)
                   {
                   if ($_ =~ /^[\t\x20].*$/)
                      {
                      $art = "$art$_\n";
                      }
                   }


                   if (@hw > 100)
                      {
                      print "Input file does not appear to be a dictionary.\n";
                      exit;
                      }


                 retrievecomm($art);
              }#___________________



sub readarticlesindic {#________________________

open(a, "$ARGV[2]") || die "could not open file: $!";

my $count = 0;
my $filesize = -s a;

while (<a>) {#- - - - - - - - - - - - - -
s/[\x0A\x0D]//g;


#\\\\\\\\\\\\\\\\\\\\
$count++;
if (($count % 10) == 0)
   {
my $offset = tell(a);
   progressinfile($offset, $filesize, "");
   }
#////////////////////



if ($_ =~ /^\x{feff}(.*)$/)
   {
   $_ = $1;
   }


if ($_ =~ /^\#(NAME.*|INDEX_LANGUAGE.*|CONTENTS_LANGUAGE.*)$/)
   {

   }
elsif (($_ =~ /^$/) && (@arr1 == 0))
   {

   }
elsif (($_ =~ /^[\t\x20].*$/) && (@arr1 == 0))
   {

   }
elsif ($_ =~ /^[^\t\x20].*$/)
    {

    if (($flag == 0) || ($flag == 2))
       {
       if (@arr1 > 0)
          {
          printarray(@arr1);
          }
          @arr1 = ();
          push @arr1, $_;
       }
       else
          {
          push @arr1, $_;
          } 

    $flag = 1;
    }
    else
        {
        push @arr1, $_;
        $flag = 2;

        }

            }#- - - - - - - - - - - - - - 


          if (@arr1 > 0)
          {
          printarray(@arr1);
          @arr1 = ();
          }

   my $offset = tell(a);
   progressinfile($offset, $filesize, "");


         close a;

      }#________________________




sub sortandwrite {#________________________

open(b, ">$ARGV[3]") || die "could not open file: $!";
open(LIST, ">symblist.txt") || die "could not open file: $!";

my @sorted = sort { $a cmp $b } @between;
@between = ();
my @temp = ();



while (my $element = shift(@sorted)) {#- - - - - -

           if (@temp == 0)
              {
              push @temp, $element;
              }
              else
                 {
                   if ($element ne $temp[$#temp])
                      {
                      push @temp, $element;
                      }

                 }

                                      }#- - - - - -

my @result = sort { $a cmp $b } @temp;
@temp = ();

foreach(@result)
       {
       print b "$_\n";
       }

#///////////////////////////

sub symb{#..............................
     my @k = keys %hash1;
     my @sk = sort { $a cmp $b } @k;	
     print LIST "#SYMBOL:\n";
     foreach(@sk)
            {
            print LIST "$_\n";
            }

       }#..............................


sub word{#..............................
     my @k = keys %hash2;
     my @sk = sort { $a cmp $b } @k;	
     print LIST "#WORD:\n";
     foreach(@sk)
            {
            print LIST "$_\n";
            }

       }#..............................

&symb;
&word;

#\\\\\\\\\\\\\\\\\\\\\\\\\\\

close b;
close LIST;
}#________________________


sub readtext {#________________________
open(a, "$ARGV[2]") || die "could not open file: $!";

my $count = 0;
my $filesize = -s a;

while (<a>) {#- - - - - - - - - - - - - -
s/[\x0A\x0D]//g;

#\\\\\\\\\\\\\\\\\\\\
$count++;
if (($count % 5) == 0)
   {
my $offset = tell(a);
   progressinfile($offset, $filesize, "");
   }
#////////////////////

if ($_ =~ /^\x{feff}(.*)$/)
   {
   $_ = $1;
   }

   retrievecomm($_);

	    }#- - - - - - - - - - - - - -

   my $offset = tell(a);
   progressinfile($offset, $filesize, "");


close a;
}#________________________
