#tags_list_v1_0_3.pl
#command line:
#script.pl input.txt output.txt



use strict;
use POSIX qw(ceil floor);

open(a, "$ARGV[0]") || die "could not open file: $!";
open(b, ">$ARGV[1]") || die "could not open file: $!";

my %hash = ();


sub slash {#__________________
	my $s = shift;

        $s =~ s/^<\/?(.*)>$/$1/;
	
	return $s;
	 }#__________________


sub progressinfile {#______________________
	my $state = shift;
        my $max = shift;
	my $message = shift;

   my $percent = ($state/$max)*100;
   $percent = floor($percent);

   for(my $k=0;$k<$percent;$k=$k+5)
      {
		print "|";						
      }

        print "$percent% $message";
        print "\r";

	 }#______________________


my $count = 0;
my $filesize = -s a;


while (<a>) {#- - - - - - -
s/[\x0A\x0D]//g;

$count++;
if (($count % 2) == 0)
   {
my $offset = tell(a);
   progressinfile($offset, $filesize, "");
   }


$_ =~ s/,/\&\#44;/g;
$_ =~ s/</,</g;
$_ =~ s/>/>,/g;

my @article = split(/,/, $_);

foreach(@article)
       {
       if ($_ =~ /^<[^<>]+>$/)
          {
          $hash{$_} = 'x';
          }
       }

            }#- - - - - - - 



my @sk = keys %hash;

my @result = sort { slash($a) cmp slash($b) } @sk;

foreach(@result)
       {
       $_ =~ s/\&\#44;/,/g;
       print b "$_\n";
       }

my $offset = tell(a);
progressinfile($offset, $filesize, 'OK');


close a;
close b;
